LeetCode 2997.使数组异或和等于K的最少操作次数

给你一个下标从 0 开始的整数数组 nums 和一个正整数 k 。

你可以对数组执行以下操作 任意次 :

选择数组里的 任意 一个元素,并将它的 二进制 表示 翻转 一个数位,翻转数位表示将 0 变成 1 或者将 1 变成 0 。

你的目标是让数组里 所有 元素的按位异或和得到 k ,请你返回达成这一目标的 最少 操作次数。

注意,你也可以将一个数的前导 0 翻转。比方说,数字 (101)2 翻转第四个数位,得到 (1101)2 。

示例 1:

输入:nums = 2,1,3,4, k = 1

输出:2

解释:我们可以执行以下操作:

  • 选择下标为 2 的元素,也就是 3 == (011)2 ,我们翻转第一个数位得到 (010)2 == 2 。数组变为 2,1,2,4 。
  • 选择下标为 0 的元素,也就是 2 == (010)2 ,我们翻转第三个数位得到 (110)2 == 6 。数组变为 6,1,2,4 。
    最终数组的所有元素异或和为 (6 XOR 1 XOR 2 XOR 4) == 1 == k 。
    无法用少于 2 次操作得到异或和等于 k 。
    示例 2:

输入:nums = 2,0,2,0, k = 0

输出:0

解释:数组所有元素的异或和为 (2 XOR 0 XOR 2 XOR 0) == 0 == k 。所以不需要进行任何操作。

提示:

1 <= nums.length <= 105

0 <= numsi <= 106

0 <= k <= 106

先求出数组中所有数字的异或和,然后看看与k差几位即可:

cpp 复制代码
class Solution {
public:
    int minOperations(vector<int>& nums, int k) {
        int xorRes = 0;
        for (int num : nums)
        {
            xorRes ^= num;
        }

        int diff = xorRes ^ k;
        int ans = 0;
        while (diff)
        {
            ++ans;
            diff = diff & (diff - 1);
        }

        return ans;
    }
};

如果nums的长度为n,则此算法时间复杂度为O(n),空间复杂度为O(1)。

相关推荐
飞Link14 分钟前
什么是 PX4?一文了解 PX4 在空地协同中的作用
算法·无人机
一去不复返的通信er7 小时前
力扣-图论-岛屿数量
算法·leetcode·图论
程序 代码狂人10 小时前
切片表与分区表的区别(数据开发面试版)
java·大数据·开发语言·数据仓库·算法
HDU-Dade10 小时前
【校招笔试真题】简要介绍 Self-Attention 的前沿算法
人工智能·算法
Xin77011 小时前
LeetCode 79. 单词搜索(DFS 回溯法)
leetcode
小郎君65812 小时前
Vue keep-alive 切标签后滚动位置回顶?因为 onDeactivated 里读到的 scrollTop 是 0
算法
邵奈一13 小时前
GPT-6.1 Terra速度是Sol的3倍,价格减半
算法
RaaS10013 小时前
Node.js Brotli RCE 漏洞自查指南:fetch、undici、axios 都在影响面,三分钟确认你的版本
人工智能·深度学习·算法
shehuiyuelaiyuehao13 小时前
算法56,重排链表
数据结构·算法·链表